<template>
  <div id="enrollment-waiting-list-wrapper">
    <el-button icon="el-icon-refresh" :key="refreshDisable" style="float: right; margin-right: 20px;" type="success"
      @click="$listeners['refreshAllList']()" :disabled="refreshDisable">{{ $t('TEACHER_CLASS.REFRESH') }}</el-button>
    <span style="float: right; margin-right: 20px; line-height: 250%;" v-if="refreshCountDown > 0">{{ $t('TEACHER_CLASS.TRY_AFT', { time: refreshCountDown }) }}</span>
    <el-table :data="waitingList" class="elTable-label" @selection-change="handleSelectionChange" :empty-text="$t('ENROLL_TABLE.EMPTY_DATA')">
      <el-table-column
        ref="multipleTable"
        type="selection"
        align="center">
      </el-table-column>

      <el-table-column
        type="index"
        width="50">
      </el-table-column>

      <el-table-column
        prop="user.email_id"
        :label="$t('TEACHER_CLASS.EMAIL')"
        align="left"
      ></el-table-column>

      <el-table-column
        prop="user.name"
        :label="$t('TEACHER_CLASS.NAME')"
        width="200"
        align="left"
      ></el-table-column>

      <el-table-column
        prop="created_at"
        :label="$t('TEACHER_CLASS.ENROLL_TIME')"
        width="300"
        align="left"
      ></el-table-column>

      <el-table-column
        label="-"
        width="125"
        align="center"
      >
        <template slot-scope="scope">
          <el-button type="primary" @click="accept(scope.row.user)" class="accept-btn">{{ $t('TEACHER_CLASS.ACCEPT') }}</el-button>
        </template>
      </el-table-column>

      <el-table-column
        label="-"
        width="125"
        align="center"
      >
        <template slot-scope="scope">
          <el-button type="danger" @click="reject(scope.row.user)" class="reject-btn">{{ $t('TEACHER_CLASS.REJECT') }}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <div class="selection_btns">
      <el-button type="primary" @click="selection('accept')" class="accept-btn">{{ $t('TEACHER_CLASS.SEL_ACCEPT') }}</el-button>
      <el-button type="danger" @click="selection('reject')" class="reject-btn">{{ $t('TEACHER_CLASS.SEL_REJECT') }}</el-button>
    </div>
  </div>
</template>

<script>
import enrollmentService from '../../services/enrollmentService';

export default {
  name: 'EnrollmentWaitingList',
  props: {
    waitingList: {
      type: Array
    },
    refreshDisable: {
      type: Boolean
    },
    refreshCountDown: {
      type: Number
    },
    classId: {
      type: Number
    }
  },
  data() {
    return {
      multipleSelection: [],
    };
  },
  mounted() {
    const vm = this;
    vm.$listeners['refreshWaitingList']();
  },
  // computed: {
  //   classId() {
  //     const vm = this;
  //     return Number.parseInt(vm.$route.params.classId, 10);
  //   },
  // },
  methods: {
    handleSelectionChange(val) {
      const vm = this;
      vm.multipleSelection = val;
    },
    accept(data) {
      const vm = this;
      vm.$confirm( vm.$t('TEACHER_CLASS.ACCEPT_STU_ENROLL_QUES', { name: data.name }), vm.$t('TEACHER_CLASS.STUDENT_ENROLLMENT'), {
        confirmButtonText: vm.$t('TEACHER_CLASS.YES'),
        cancelButtonText: vm.$t('TEACHER_CLASS.NO'),
        type: 'warning',
      }).then(async () => {
        const permitResult = await enrollmentService.permitEnrollment({
          class_id: vm.classId,
          user_id: data.user_id,
        });
        vm.$notify({
          title: vm.$t('TEACHER_CLASS.STUDENT_ENROLLMENT'),
          message: vm.$t('TEACHER_CLASS.ACCEPT_STU_ENROLL', { name: data.name }),
          duration: 3000,
          type: 'success',
        });
        vm.$listeners['refreshWaitingList']();
      }).catch((err) => {
        vm.$notify({
          title: vm.$t('TEACHER_CLASS.STUDENT_ENROLLMENT'),
          message: vm.$t('TEACHER_CLASS.CANCEL_ACCEPT_STU'),
          duration: 3000,
          type: 'warning',
        });
      });
    },
    reject(data) {
      const vm = this;
      vm.$confirm( vm.$t('TEACHER_CLASS.REJECT_STU_ENROLL_QUES', { name: data.name }), vm.$t('TEACHER_CLASS.STUDENT_ENROLLMENT'), {
        confirmButtonText: vm.$t('TEACHER_CLASS.YES'),
        cancelButtonText: vm.$t('TEACHER_CLASS.NO'),
        type: 'warning',
      }).then(async () => {
        const permitResult = await enrollmentService.rejectEnrollment({
          class_id: vm.classId,
          user_id: data.user_id,
        });
        vm.$notify({
          title: vm.$t('TEACHER_CLASS.STUDENT_ENROLLMENT'),
          message: vm.$t('TEACHER_CLASS.REJECT_STU_ENROLL', { name: data.name }),
          duration: 3000,
          type: 'success',
        });
        vm.$listeners['refreshWaitingList']();
      }).catch((err) => {
        vm.$notify({
          title: vm.$t('TEACHER_CLASS.STUDENT_ENROLLMENT'),
          message: vm.$t('TEACHER_CLASS.CANCEL_REJECT_STU'),
          duration: 3000,
          type: 'warning',
        });
      });
    },
    selection(type) {
      const vm = this;
      if (vm.multipleSelection.length === 0) {
        vm.$notify({
          title: vm.$t('TEACHER_CLASS.SEL_ERROR'),
          message: vm.$t('TEACHER_CLASS.SEL_ERROR_MSG'),
          duration: 3000,
          type: 'warning',
        })
        return;
      }
      switch (type) {
        case 'accept': {
          vm.$confirm( vm.$t('TEACHER_CLASS.ACCEPT_MUL_ENROLL_QUES', { num: vm.multipleSelection.length }), vm.$t('TEACHER_CLASS.STUDENT_ENROLLMENT'), {
            confirmButtonText: vm.$t('TEACHER_CLASS.YES'),
            cancelButtonText: vm.$t('TEACHER_CLASS.NO'),
            type: 'warning',
          }).then(async () => {
            const promiseTodo = [];
            vm.multipleSelection.forEach((selection) => {
              promiseTodo.push(enrollmentService.permitEnrollment({
                class_id: vm.classId,
                user_id: selection.user_id,
              }));
            });
            Promise.all(promiseTodo).then((result) => {
              vm.$notify({
                title: vm.$t('TEACHER_CLASS.STUDENT_ENROLLMENT'),
                message: vm.$t('TEACHER_CLASS.ACCEPT_MUL_ENROLL', { num: vm.multipleSelection.length }),
                duration: 3000,
                type: 'success',
              });
              vm.$listeners['refreshWaitingList']();
            });
          }).catch((err) => {
            vm.$notify({
              title: vm.$t('TEACHER_CLASS.STUDENT_ENROLLMENT'),
              message: vm.$t('TEACHER_CLASS.CANCEL_ACCEPT_STU'),
              duration: 3000,
              type: 'warning',
            });
          });
          break;
        }
        case 'reject': {
          vm.$confirm( vm.$t('TEACHER_CLASS.REJECT_MUL_ENROLL_QUES', { num: vm.multipleSelection.length }), vm.$t('TEACHER_CLASS.STUDENT_ENROLLMENT'), {
            confirmButtonText: vm.$t('TEACHER_CLASS.YES'),
            cancelButtonText: vm.$t('TEACHER_CLASS.NO'),
            type: 'warning',
          }).then(async () => {
            const promiseTodo = [];
            vm.multipleSelection.forEach((selection) => {
              promiseTodo.push(enrollmentService.rejectEnrollment({
                class_id: vm.classId,
                user_id: selection.user_id,
              }));
            });
            Promise.all(promiseTodo).then((result) => {
              vm.$notify({
                title: vm.$t('TEACHER_CLASS.STUDENT_ENROLLMENT'),
                message: vm.$t('TEACHER_CLASS.REJECT_MUL_ENROLL', { num: vm.multipleSelection.length }),
                duration: 3000,
                type: 'success',
              });
              vm.$listeners['refreshWaitingList']();
            });
          }).catch((err) => {
            vm.$notify({
              title: vm.$t('TEACHER_CLASS.STUDENT_ENROLLMENT'),
              message: vm.$t('TEACHER_CLASS.CANCEL_REJECT_STU'),
              duration: 3000,
              type: 'warning',
            });
          });
          break;
        }
      }
    }
  }
};
</script>

<style lang="scss" scoped>
#enrollment-waiting-list-wrapper {
  .selection_btns {
    margin-top: 10px;
  }
}
</style>